unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Aurelius.Engine.objectmanager, Aurelius.Engine.DatabaseManager,
  Aurelius.Comp.DBSchema, Aurelius.Events.manager, Aurelius.mapping.explorer,
  Data.DB, Aurelius.Bind.BaseDataset, Aurelius.Bind.Dataset, Vcl.Grids,
  Vcl.DBGrids;

type

  TITem = class
  private
    FDescricao: String;
    Ftipo: Integer;
    procedure SetDescricao(const Value: String);
    procedure Settipo(const Value: Integer);
  published
    Property Descricao: String read FDescricao write SetDescricao;
    Property tipo: Integer read Ftipo write Settipo;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    AureliusDataset1: TAureliusDataset;
    AureliusDataset1Descricao: TStringField;
    AureliusDataset1Tipo: TIntegerField;
    procedure Button1Click(Sender: TObject);
    procedure AureliusDataset1FilterRecord(Dataset: TDataSet; var Accept: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses System.generics.collections;

procedure TForm1.AureliusDataset1FilterRecord(Dataset: TDataSet; var Accept: Boolean);
begin
  Accept := (Dataset.FieldByName('Tipo').AsInteger = 5);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin

  AureliusDataset1.close;
  AureliusDataset1.SetSourceList(TList<TITem>.create);
  AureliusDataset1.Open;

  for I := 0 to 10 do
  Begin
    AureliusDataset1.Append;
    AureliusDataset1Descricao.Value := 'item' + I.ToString;
    AureliusDataset1Tipo.Value := I;
    AureliusDataset1.Post;
  End;

  AureliusDataset1.Filtered := True;

  showmessage(AureliusDataset1.RecordCount.ToString);

end;

{ TITem }

procedure TITem.SetDescricao(const Value: String);
begin
  FDescricao := Value;
end;

procedure TITem.Settipo(const Value: Integer);
begin
  Ftipo := Value;
end;

end.
